
local function draw_status(x,y,src)

   local msg_table = {
      [0]   = "Stop",
      [1]   = "Ready",
      [2]   = "Ign(StickDown)",
      [3]   = "Ignition",
      [4]   = "Preheat",
      [5]   = "Fuelramp",
      [6]   = "Learn,StickMax",
      [7]   = "Learn,StickMin",
      [8]   = "Learn Rc...",
      [9]   = "Run(StickMin)",
      [10]  = "Run(PumpLimit)",
      [11]  = "Running",
      [12]  = "Cooling",
      [13]  = "Restart",
      [14]  = "TestGlowPlug",
      [15]  = "TestFuelValve",
      [16]  = "TestGasValve",
      [17]  = "TestPump",
      [18]  = "TestStarter",
      [19]  = "ExhaustAir",
	  [-1]  = "Time Out",
	  [-2]  = "Low Battery",
	  [-3]  = "GlowPlug Bad",
	  [-4]  = "Fuel Anomaly",
	  [-5]  = "Starter failure",
	  [-6]  = "RPM Low",
	  [-7]  = "RPM Instability",
	  [-8]  = "High Temperature",
	  [-9]  = "Low Temperature",
	  [-10] = "Temp Sensor failure",
	  [-11] = "Gas Valve Bad",
	  [-12] = "Fuel Valve Bad",
	  [-13] = "Lost Signal",
	  [-14] = "Starter Temp High",
	  [-15] = "Pump Temp High",
	  [-16] = "Clutch failure",
      [-17] = "Current overload",
      [-18] = "Engine Offline",
   }

   local status = getValue(src)
   local status_str = msg_table[status] or tostring(status)
      
   lcd.drawText(x+30,y+2,"STATUS",0)
   lcd.drawText(x+10,y+12,status_str, MIDSIZE)
end

local function draw_rpm(x,y,src)
   local rpm = getValue(src)
   lcd.drawPixmap(x+4,y+3,"/SCRIPTS/BMP/rpm.bmp")
   lcd.drawText(x+32,y+9,"RPM",0)
   lcd.drawNumber(x+50,y+19,rpm, RIGHT + MIDSIZE)
end

local function draw_egt(x,y,src)
   local egt = getValue(src)
   lcd.drawPixmap(x+7,y+7,"/SCRIPTS/BMP/temp.bmp")
   lcd.drawText(x+32,y+4,"EGT",0)
   lcd.drawNumber(x+50,y+14,egt, RIGHT + MIDSIZE)
end

local function draw_current(x,y,src)
   local current = getValue(src)*10
   lcd.drawText(x+28,y+4,"Current",0)
   lcd.drawText(x+52,y+15,"A",MIDSIZE)
   lcd.drawNumber(x+50,y+15,current,PREC1 + RIGHT + MIDSIZE)
end

local function draw_battery(x,y,src)
   local batt_v = getValue(src)*10
   lcd.drawPixmap(x+4,y+3,"/SCRIPTS/BMP/battery.bmp")
   lcd.drawText(x+28,y+4,"PwrVol",0)
   lcd.drawText(x+52,y+15,"V",MIDSIZE)
   lcd.drawNumber(x+50,y+15,batt_v,PREC1 + RIGHT + MIDSIZE)
end

local function draw_speed(x,y,src)
   local speed = getValue(src)*10
   lcd.drawPixmap(x+3,y+3,"/SCRIPTS/BMP/speed.bmp")
   lcd.drawText(x+60,y+4,"SPEED",0)
   lcd.drawNumber(x+89,y+16,speed,PREC1 + RIGHT + DBLSIZE)
end

local function run(event)

   local rpm    = "RPM"
   local egt    = "Tmp1"
   local batt_v = "VFAS"
   local current= "Curr"
   local status = "Tmp2"
   local speed  = "VSpd"

   lcd.clear()

   draw_rpm(0,0,rpm)
   lcd.drawLine(0,35,53,35,DOTTED,FORCE)

   draw_egt(0,36,egt)
   lcd.drawLine(54,0,54,63,DOTTED,FORCE)

   draw_speed(55,0,speed)
   lcd.drawLine(55,35,147,35,DOTTED,FORCE)

   draw_status(55,38,status)
   lcd.drawLine(148,0,148,63,DOTTED,FORCE)

   draw_current(149,0,current)
   lcd.drawLine(149,35,211,35,DOTTED,FORCE)

   draw_battery(149,36,batt_v)
   
   --[[

   batt_v = getValue(batt_v)
   lcd.drawText(1,31,"Batt",0)
   lcd.drawNumber(60,31,batt_v*10,PREC1)
   
   pump_v = getValue(pump_v)
   lcd.drawText(1,41,"Pump",0)
   lcd.drawNumber(60,41,pump_v*10,PREC1)

   status = get_status(status)
   lcd.drawText(1,51,status,0)
   --]]
   
end

return {run=run}
